import { StyleProp, ViewStyle } from 'react-native';

declare const palette: {
    light: Record<`--color-${string}`, string>;
    dark: Record<`--color-${string}`, string>;
};
declare const lightVariants: {
    placeholderText: string;
    separator: string;
    opaqueSeparator: string;
    nonOpaqueSeparator: string;
    link: string;
    systemBackground: string;
    secondarySystemBackground: string;
    tertiarySystemBackground: string;
    systemGroupedBackground: string;
    secondarySystemGroupedBackground: string;
    tertiarySystemGroupedBackground: string;
    systemFill: string;
    secondarySystemFill: string;
    tertiarySystemFill: string;
    quaternarySystemFill: string;
    label: string;
    text: string;
    secondaryLabel: string;
    tertiaryLabel: string;
    quaternaryLabel: string;
};
declare const darkVariants: {
    placeholderText: string;
    separator: string;
    opaqueSeparator: string;
    nonOpaqueSeparator: string;
    link: string;
    systemBackground: string;
    secondarySystemBackground: string;
    tertiarySystemBackground: string;
    systemGroupedBackground: string;
    secondarySystemGroupedBackground: string;
    tertiarySystemGroupedBackground: string;
    systemFill: string;
    secondarySystemFill: string;
    tertiarySystemFill: string;
    quaternarySystemFill: string;
    label: string;
    text: string;
    secondaryLabel: string;
    tertiaryLabel: string;
    quaternaryLabel: string;
};
declare const mergedLightColors: {
    red: string;
    orange: string;
    yellow: string;
    green: string;
    mint: string;
    teal: string;
    cyan: string;
    blue: string;
    indigo: string;
    purple: string;
    pink: string;
    brown: string;
    gray: string;
    gray2: string;
    gray3: string;
    gray4: string;
    gray5: string;
    gray6: string;
    placeholderText: string;
    separator: string;
    opaqueSeparator: string;
    nonOpaqueSeparator: string;
    link: string;
    systemBackground: string;
    secondarySystemBackground: string;
    tertiarySystemBackground: string;
    systemGroupedBackground: string;
    secondarySystemGroupedBackground: string;
    tertiarySystemGroupedBackground: string;
    systemFill: string;
    secondarySystemFill: string;
    tertiarySystemFill: string;
    quaternarySystemFill: string;
    label: string;
    text: string;
    secondaryLabel: string;
    tertiaryLabel: string;
    quaternaryLabel: string;
};
declare const colorVariants: {
    light: Record<`--color-${string}`, string>;
    dark: Record<`--color-${string}`, string>;
};
declare const useColor: (color: keyof typeof mergedLightColors) => string;
declare const useColors: () => {
    red: string;
    orange: string;
    yellow: string;
    green: string;
    mint: string;
    teal: string;
    cyan: string;
    blue: string;
    indigo: string;
    purple: string;
    pink: string;
    brown: string;
    gray: string;
    gray2: string;
    gray3: string;
    gray4: string;
    gray5: string;
    gray6: string;
    placeholderText: string;
    separator: string;
    opaqueSeparator: string;
    nonOpaqueSeparator: string;
    link: string;
    systemBackground: string;
    secondarySystemBackground: string;
    tertiarySystemBackground: string;
    systemGroupedBackground: string;
    secondarySystemGroupedBackground: string;
    tertiarySystemGroupedBackground: string;
    systemFill: string;
    secondarySystemFill: string;
    tertiarySystemFill: string;
    quaternarySystemFill: string;
    label: string;
    text: string;
    secondaryLabel: string;
    tertiaryLabel: string;
    quaternaryLabel: string;
} | {
    red: string;
    orange: string;
    yellow: string;
    green: string;
    mint: string;
    teal: string;
    cyan: string;
    blue: string;
    indigo: string;
    purple: string;
    pink: string;
    brown: string;
    gray: string;
    gray2: string;
    gray3: string;
    gray4: string;
    gray5: string;
    gray6: string;
    placeholderText: string;
    separator: string;
    opaqueSeparator: string;
    nonOpaqueSeparator: string;
    link: string;
    systemBackground: string;
    secondarySystemBackground: string;
    tertiarySystemBackground: string;
    systemGroupedBackground: string;
    secondarySystemGroupedBackground: string;
    tertiarySystemGroupedBackground: string;
    systemFill: string;
    secondarySystemFill: string;
    tertiarySystemFill: string;
    quaternarySystemFill: string;
    label: string;
    text: string;
    secondaryLabel: string;
    tertiaryLabel: string;
    quaternaryLabel: string;
};
type Colors = typeof mergedLightColors;

declare const getCurrentColors: () => StyleProp<ViewStyle>;
declare const getSystemBackgroundColor: () => string;
declare const rgbStringToRgb: (hex: string) => string;

export { type Colors, colorVariants, darkVariants, getCurrentColors, getSystemBackgroundColor, lightVariants, palette, rgbStringToRgb, useColor, useColors };
